/* feedbinAPI.c generated by valac 0.42.2, the Vala compiler
 * generated from feedbinAPI.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/
/* TODO: Make a general-purpose HttpClient module with these errors*/


#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <gee.h>


#define TYPE_FEEDBIN_API (feedbin_api_get_type ())
#define FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FEEDBIN_API, FeedbinAPI))
#define FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FEEDBIN_API, FeedbinAPIClass))
#define IS_FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FEEDBIN_API))
#define IS_FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FEEDBIN_API))
#define FEEDBIN_API_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FEEDBIN_API, FeedbinAPIClass))

typedef struct _FeedbinAPI FeedbinAPI;
typedef struct _FeedbinAPIClass FeedbinAPIClass;
typedef struct _FeedbinAPIPrivate FeedbinAPIPrivate;
enum  {
	FEEDBIN_API_0_PROPERTY,
	FEEDBIN_API_USERNAME_PROPERTY,
	FEEDBIN_API_PASSWORD_PROPERTY,
	FEEDBIN_API_NUM_PROPERTIES
};
static GParamSpec* feedbin_api_properties[FEEDBIN_API_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define FEEDBIN_API_TYPE_SUBSCRIPTION (feedbin_api_subscription_get_type ())
typedef struct _FeedbinAPISubscription FeedbinAPISubscription;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define FEEDBIN_API_TYPE_TAGGING (feedbin_api_tagging_get_type ())
typedef struct _FeedbinAPITagging FeedbinAPITagging;

#define FEEDBIN_API_TYPE_ENTRY (feedbin_api_entry_get_type ())
typedef struct _FeedbinAPIEntry FeedbinAPIEntry;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

typedef enum  {
	FEEDBIN_ERROR_INVALID_FORMAT,
	FEEDBIN_ERROR_MULTIPLE_CHOICES,
	FEEDBIN_ERROR_NO_CONNECTION,
	FEEDBIN_ERROR_NOT_AUTHORIZED,
	FEEDBIN_ERROR_NOT_FOUND,
	FEEDBIN_ERROR_UNKNOWN_ERROR
} FeedbinError;
#define FEEDBIN_ERROR feedbin_error_quark ()
struct _FeedbinAPI {
	GObject parent_instance;
	FeedbinAPIPrivate * priv;
};

struct _FeedbinAPIClass {
	GObjectClass parent_class;
};

struct _FeedbinAPIPrivate {
	SoupSession* m_session;
	gchar* m_base_uri;
	gchar* _username;
	gchar* _password;
};

struct _FeedbinAPISubscription {
	gint64 id;
	GDateTime* created_at;
	gint64 feed_id;
	gchar* title;
	gchar* feed_url;
	gchar* site_url;
};

struct _FeedbinAPITagging {
	gint64 id;
	gint64 feed_id;
	gchar* name;
};

struct _FeedbinAPIEntry {
	gint64 id;
	gint64 feed_id;
	gchar* title;
	gchar* url;
	gchar* author;
	gchar* content;
	gchar* summary;
	GDateTime* published;
	GDateTime* created_at;
};


static gint FeedbinAPI_private_offset;
static gpointer feedbin_api_parent_class = NULL;

GQuark feedbin_error_quark (void);
GType feedbin_api_get_type (void) G_GNUC_CONST;
static void feedbin_api_authenticate (FeedbinAPI* self,
                               SoupMessage* msg,
                               SoupAuth* auth,
                               gboolean retrying);
static void _feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender,
                                                          SoupMessage* msg,
                                                          SoupAuth* auth,
                                                          gboolean retrying,
                                                          gpointer self);
#define FEEDBIN_API_BASE_URI_FORMAT "%s/v2/"
FeedbinAPI* feedbin_api_new (const gchar* username,
                             const gchar* password,
                             const gchar* user_agent,
                             const gchar* host);
FeedbinAPI* feedbin_api_construct (GType object_type,
                                   const gchar* username,
                                   const gchar* password,
                                   const gchar* user_agent,
                                   const gchar* host);
void feedbin_api_set_username (FeedbinAPI* self,
                               const gchar* value);
void feedbin_api_set_password (FeedbinAPI* self,
                               const gchar* value);
const gchar* feedbin_api_get_username (FeedbinAPI* self);
const gchar* feedbin_api_get_password (FeedbinAPI* self);
static SoupMessage* feedbin_api_request (FeedbinAPI* self,
                                  const gchar* method,
                                  const gchar* last_part,
                                  const gchar* input,
                                  GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          int length);
static GDateTime* feedbin_api_string_to_datetime (const gchar* s,
                                           GError** error);
static GDateTime* feedbin_api_get_datetime_member (JsonObject* obj,
                                            const gchar* name,
                                            GError** error);
static SoupMessage* feedbin_api_post_request (FeedbinAPI* self,
                                       const gchar* path,
                                       const gchar* input,
                                       GError** error);
static SoupMessage* feedbin_api_delete_request (FeedbinAPI* self,
                                         const gchar* path,
                                         const gchar* input,
                                         GError** error);
static SoupMessage* feedbin_api_get_request (FeedbinAPI* self,
                                      const gchar* path,
                                      GError** error);
static JsonNode* feedbin_api_parse_json (SoupMessage* response,
                                  GError** error);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static JsonNode* feedbin_api_get_json (FeedbinAPI* self,
                                const gchar* path,
                                GError** error);
static void _vala_JsonNode_free (JsonNode* self);
static SoupMessage* feedbin_api_post_json_object (FeedbinAPI* self,
                                           const gchar* path,
                                           JsonObject* obj,
                                           GError** error);
gboolean feedbin_api_login (FeedbinAPI* self,
                            GError** error);
GType feedbin_api_subscription_get_type (void) G_GNUC_CONST;
FeedbinAPISubscription* feedbin_api_subscription_dup (const FeedbinAPISubscription* self);
void feedbin_api_subscription_free (FeedbinAPISubscription* self);
void feedbin_api_subscription_copy (const FeedbinAPISubscription* self,
                                    FeedbinAPISubscription* dest);
void feedbin_api_subscription_destroy (FeedbinAPISubscription* self);
void feedbin_api_get_subscription (FeedbinAPI* self,
                                   gint64 subscription_id,
                                   FeedbinAPISubscription* result,
                                   GError** error);
void feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self,
                                              JsonObject* object,
                                              GError** error);
GeeList* feedbin_api_get_subscriptions (FeedbinAPI* self,
                                        GError** error);
void feedbin_api_delete_subscription (FeedbinAPI* self,
                                      gint64 subscription_id,
                                      GError** error);
FeedbinAPISubscription* feedbin_api_add_subscription (FeedbinAPI* self,
                                                      const gchar* url,
                                                      GError** error);
void feedbin_api_rename_subscription (FeedbinAPI* self,
                                      gint64 subscription_id,
                                      const gchar* title,
                                      GError** error);
void feedbin_api_add_tagging (FeedbinAPI* self,
                              gint64 feed_id,
                              const gchar* tag_name,
                              GError** error);
void feedbin_api_delete_tagging (FeedbinAPI* self,
                                 gint64 tagging_id,
                                 GError** error);
GType feedbin_api_tagging_get_type (void) G_GNUC_CONST;
FeedbinAPITagging* feedbin_api_tagging_dup (const FeedbinAPITagging* self);
void feedbin_api_tagging_free (FeedbinAPITagging* self);
void feedbin_api_tagging_copy (const FeedbinAPITagging* self,
                               FeedbinAPITagging* dest);
void feedbin_api_tagging_destroy (FeedbinAPITagging* self);
GeeList* feedbin_api_get_taggings (FeedbinAPI* self,
                                   GError** error);
void feedbin_api_tagging_init_from_json (FeedbinAPITagging *self,
                                         JsonObject* object);
GType feedbin_api_entry_get_type (void) G_GNUC_CONST;
FeedbinAPIEntry* feedbin_api_entry_dup (const FeedbinAPIEntry* self);
void feedbin_api_entry_free (FeedbinAPIEntry* self);
void feedbin_api_entry_copy (const FeedbinAPIEntry* self,
                             FeedbinAPIEntry* dest);
void feedbin_api_entry_destroy (FeedbinAPIEntry* self);
GeeList* feedbin_api_get_entries (FeedbinAPI* self,
                                  gint page,
                                  gboolean only_starred,
                                  GDateTime* since,
                                  gint64* feed_id,
                                  GError** error);
void feedbin_api_entry_init_from_json (FeedbinAPIEntry *self,
                                       JsonObject* object,
                                       GError** error);
static GeeSet* feedbin_api_get_x_entries (FeedbinAPI* self,
                                   const gchar* path,
                                   GError** error);
static guint __lambda4_ (FeedbinAPI* self,
                  gint64* n);
static guint ___lambda4__gee_hash_data_func (gconstpointer v,
                                      gpointer self);
static gboolean __lambda5_ (FeedbinAPI* self,
                     gint64* a,
                     gint64* b);
static gboolean ___lambda5__gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint64* _int64_dup (gint64* self);
GeeSet* feedbin_api_get_unread_entries (FeedbinAPI* self,
                                        GError** error);
GeeSet* feedbin_api_get_starred_entries (FeedbinAPI* self,
                                         GError** error);
static void feedbin_api_set_entries_status (FeedbinAPI* self,
                                     const gchar* type,
                                     GeeCollection* entry_ids,
                                     gboolean create,
                                     GError** error);
void feedbin_api_set_entries_read (FeedbinAPI* self,
                                   GeeCollection* entry_ids,
                                   gboolean read,
                                   GError** error);
void feedbin_api_set_entries_starred (FeedbinAPI* self,
                                      GeeCollection* entry_ids,
                                      gboolean starred,
                                      GError** error);
GeeMap* feedbin_api_get_favicons (FeedbinAPI* self,
                                  GError** error);
static void feedbin_api_finalize (GObject * obj);
static void _vala_feedbin_api_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_feedbin_api_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


GQuark
feedbin_error_quark (void)
{
	return g_quark_from_static_string ("feedbin_error-quark");
}


static inline gpointer
feedbin_api_get_instance_private (FeedbinAPI* self)
{
	return G_STRUCT_MEMBER_P (self, FeedbinAPI_private_offset);
}


static void
_feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender,
                                                     SoupMessage* msg,
                                                     SoupAuth* auth,
                                                     gboolean retrying,
                                                     gpointer self)
{
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_authenticate ((FeedbinAPI*) self, msg, auth, retrying);
#line 311 "feedbinAPI.c"
}


FeedbinAPI*
feedbin_api_construct (GType object_type,
                       const gchar* username,
                       const gchar* password,
                       const gchar* user_agent,
                       const gchar* host)
{
	FeedbinAPI * self = NULL;
	gchar* _tmp0_;
	SoupSession* _tmp1_;
	SoupSession* _tmp3_;
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	self = (FeedbinAPI*) g_object_new (object_type, NULL);
#line 36 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_username (self, username);
#line 37 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_password (self, password);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf (FEEDBIN_API_BASE_URI_FORMAT, host);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->m_base_uri);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv->m_base_uri = _tmp0_;
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = soup_session_new ();
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (self->priv->m_session);
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv->m_session = _tmp1_;
#line 41 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (user_agent != NULL) {
#line 350 "feedbinAPI.c"
		SoupSession* _tmp2_;
#line 42 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = self->priv->m_session;
#line 42 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_set (_tmp2_, "user-agent", user_agent, NULL);
#line 356 "feedbinAPI.c"
	}
#line 44 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = self->priv->m_session;
#line 44 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_connect_object (_tmp3_, "authenticate", (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self, 0);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self;
#line 364 "feedbinAPI.c"
}


FeedbinAPI*
feedbin_api_new (const gchar* username,
                 const gchar* password,
                 const gchar* user_agent,
                 const gchar* host)
{
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	return feedbin_api_construct (TYPE_FEEDBIN_API, username, password, user_agent, host);
#line 376 "feedbinAPI.c"
}


static void
feedbin_api_authenticate (FeedbinAPI* self,
                          SoupMessage* msg,
                          SoupAuth* auth,
                          gboolean retrying)
{
#line 52 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 52 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (msg != NULL);
#line 52 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (auth != NULL);
#line 54 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (!retrying) {
#line 394 "feedbinAPI.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 55 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = self->priv->_username;
#line 55 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = self->priv->_password;
#line 55 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_auth_authenticate (auth, _tmp0_, _tmp1_);
#line 403 "feedbinAPI.c"
	}
}


static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1499 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1499 "glib-2.0.vapi"
	res_length1 = -1;
#line 1499 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1500 "glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1501 "glib-2.0.vapi"
	_tmp3_ = res;
#line 1501 "glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1501 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1501 "glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1501 "glib-2.0.vapi"
	if (result_length1) {
#line 1501 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 451 "feedbinAPI.c"
	}
#line 1501 "glib-2.0.vapi"
	result = _tmp4_;
#line 1501 "glib-2.0.vapi"
	return result;
#line 457 "feedbinAPI.c"
}


static guint8*
_vala_array_dup1 (guint8* self,
                  int length)
{
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 467 "feedbinAPI.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1513 "glib-2.0.vapi"
	result = self;
#line 1513 "glib-2.0.vapi"
	return result;
#line 481 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_request (FeedbinAPI* self,
                     const gchar* method,
                     const gchar* last_part,
                     const gchar* input,
                     GError** error)
{
	SoupMessage* result = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	gboolean _tmp4_ = FALSE;
	SoupSession* _tmp12_;
	SoupMessage* _tmp13_;
	guint status = 0U;
	SoupMessage* _tmp14_;
	guint _tmp15_;
	guint _tmp16_;
	gboolean _tmp17_ = FALSE;
	guint _tmp18_;
	GError * _inner_error_ = NULL;
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (method != NULL, NULL);
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (last_part != NULL, NULL);
#line 60 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->m_base_uri;
#line 60 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strconcat (_tmp0_, last_part, NULL);
#line 60 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp1_;
#line 61 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = path;
#line 61 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = soup_message_new (method, _tmp2_);
#line 61 "../plugins/backend/feedbin/feedbinAPI.vala"
	message = _tmp3_;
#line 63 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (method, "POST") == 0) {
#line 63 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = TRUE;
#line 531 "feedbinAPI.c"
	} else {
#line 63 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = g_strcmp0 (method, "PUT") == 0;
#line 535 "feedbinAPI.c"
	}
#line 63 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp4_) {
#line 539 "feedbinAPI.c"
		SoupMessage* _tmp5_;
		SoupMessageHeaders* _tmp6_;
#line 64 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp5_ = message;
#line 64 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = _tmp5_->request_headers;
#line 64 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_message_headers_append (_tmp6_, "Content-Type", "application/json; charset=utf-8");
#line 548 "feedbinAPI.c"
	}
#line 66 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (input != NULL) {
#line 552 "feedbinAPI.c"
		SoupMessage* _tmp7_;
		SoupMessageBody* _tmp8_;
		guint8* _tmp9_;
		gint _tmp9__length1;
		guint8* _tmp10_;
		gint _tmp10__length1;
		guint8* _tmp11_;
		gint _tmp11__length1;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp7_ = message;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = _tmp7_->request_body;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = string_get_data (input, &_tmp9__length1);
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp10_ = _tmp9_;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp10__length1 = _tmp9__length1;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup1 (_tmp10_, _tmp10__length1) : ((gpointer) _tmp10_);
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11__length1 = _tmp10__length1;
#line 67 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_message_body_append_take (_tmp8_, _tmp11_, (gsize) _tmp11__length1);
#line 577 "feedbinAPI.c"
	}
#line 69 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = self->priv->m_session;
#line 69 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = message;
#line 69 "../plugins/backend/feedbin/feedbinAPI.vala"
	soup_session_send_message (_tmp12_, _tmp13_);
#line 70 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp14_ = message;
#line 70 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp14_, "status-code", &_tmp15_, NULL);
#line 70 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp16_ = _tmp15_;
#line 70 "../plugins/backend/feedbin/feedbinAPI.vala"
	status = _tmp16_;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp18_ = status;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp18_ < ((guint) 200)) {
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = TRUE;
#line 599 "feedbinAPI.c"
	} else {
		guint _tmp19_;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = status;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp19_ >= ((guint) 400);
#line 606 "feedbinAPI.c"
	}
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp17_) {
#line 610 "feedbinAPI.c"
		guint _tmp20_;
		gchar* phrase = NULL;
		guint _tmp41_;
		const gchar* _tmp42_;
		gchar* _tmp43_;
		guint _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		GError* _tmp54_;
		GError* _tmp55_;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp20_ = status;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
		switch (_tmp20_) {
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_RESOLVE:
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_RESOLVE_PROXY:
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_CONNECT:
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_CONNECT_PROXY:
#line 640 "feedbinAPI.c"
			{
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				GError* _tmp25_;
				GError* _tmp26_;
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp21_ = self->priv->m_base_uri;
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp22_ = string_to_string (_tmp21_);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp23_ = g_strconcat ("Connection to ", _tmp22_, " failed", NULL);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp24_ = _tmp23_;
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp25_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NO_CONNECTION, _tmp24_);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp26_ = _tmp25_;
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp24_);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error_ = _tmp26_;
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error_);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 674 "feedbinAPI.c"
				} else {
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error_);
#line 79 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 686 "feedbinAPI.c"
				}
			}
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_UNAUTHORIZED:
#line 691 "feedbinAPI.c"
			{
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				GError* _tmp32_;
				GError* _tmp33_;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp27_ = string_to_string (method);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp28_ = path;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp29_ = string_to_string (_tmp28_);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp30_ = g_strconcat ("Not authorized to ", _tmp27_, " ", _tmp29_, NULL);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp31_ = _tmp30_;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp32_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED, _tmp31_);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp33_ = _tmp32_;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp31_);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error_ = _tmp33_;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error_);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 728 "feedbinAPI.c"
				} else {
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error_);
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 740 "feedbinAPI.c"
				}
			}
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_NOT_FOUND:
#line 745 "feedbinAPI.c"
			{
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				GError* _tmp39_;
				GError* _tmp40_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp34_ = string_to_string (method);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp35_ = path;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp36_ = string_to_string (_tmp35_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp37_ = g_strconcat (_tmp34_, " ", _tmp36_, " not found", NULL);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp38_ = _tmp37_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp39_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND, _tmp38_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp40_ = _tmp39_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp38_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error_ = _tmp40_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 782 "feedbinAPI.c"
				} else {
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error_);
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 794 "feedbinAPI.c"
				}
			}
			default:
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
			break;
#line 800 "feedbinAPI.c"
		}
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp41_ = status;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp42_ = soup_status_get_phrase (_tmp41_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp43_ = g_strdup (_tmp42_);
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
		phrase = _tmp43_;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp44_ = status;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp45_ = g_strdup_printf ("%u", _tmp44_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp46_ = _tmp45_;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp47_ = phrase;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp48_ = string_to_string (_tmp47_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp49_ = string_to_string (method);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp50_ = path;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp51_ = string_to_string (_tmp50_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp52_ = g_strconcat ("Unexpected status ", _tmp46_, " (", _tmp48_, ") for ", _tmp49_, " ", _tmp51_, NULL);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp53_ = _tmp52_;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp54_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_UNKNOWN_ERROR, _tmp53_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp55_ = _tmp54_;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp53_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp46_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp55_;
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (phrase);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (message);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 852 "feedbinAPI.c"
		} else {
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (phrase);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (message);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 86 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 866 "feedbinAPI.c"
		}
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (phrase);
#line 870 "feedbinAPI.c"
	}
#line 88 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = message;
#line 88 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 88 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 878 "feedbinAPI.c"
}


static GDateTime*
feedbin_api_string_to_datetime (const gchar* s,
                                GError** error)
{
	GDateTime* result = NULL;
	GTimeVal time = {0};
	GTimeVal _tmp5_;
	GDateTime* _tmp6_;
	GError * _inner_error_ = NULL;
#line 92 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 94 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_get_current_time (&time);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (!g_time_val_from_iso8601 (s, &time)) {
#line 897 "feedbinAPI.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = string_to_string (s);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = g_strconcat ("Expected date but got ", _tmp0_, NULL);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = _tmp1_;
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp2_);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = _tmp3_;
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp2_);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp4_;
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 923 "feedbinAPI.c"
		} else {
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 96 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 931 "feedbinAPI.c"
		}
	}
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = time;
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_date_time_new_from_timeval_utc (&_tmp5_);
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp6_;
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 942 "feedbinAPI.c"
}


static GDateTime*
feedbin_api_get_datetime_member (JsonObject* obj,
                                 const gchar* name,
                                 GError** error)
{
	GDateTime* result = NULL;
	gchar* s = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GDateTime* _tmp2_ = NULL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError * _inner_error_ = NULL;
#line 101 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 101 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 103 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (obj, name);
#line 103 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 103 "../plugins/backend/feedbin/feedbinAPI.vala"
	s = _tmp1_;
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = feedbin_api_string_to_datetime (s, &_inner_error_);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp3_;
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (s);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 983 "feedbinAPI.c"
		} else {
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (s);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 993 "feedbinAPI.c"
		}
	}
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp2_;
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = NULL;
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp4_;
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp2_);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (s);
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1008 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_post_request (FeedbinAPI* self,
                          const gchar* path,
                          const gchar* input,
                          GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 107 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 107 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "POST", path, input, &_inner_error_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1041 "feedbinAPI.c"
		} else {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1049 "feedbinAPI.c"
		}
	}
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1062 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_delete_request (FeedbinAPI* self,
                            const gchar* path,
                            const gchar* input,
                            GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 112 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "DELETE", path, input, &_inner_error_);
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1093 "feedbinAPI.c"
		} else {
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1101 "feedbinAPI.c"
		}
	}
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 114 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1114 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_get_request (FeedbinAPI* self,
                         const gchar* path,
                         GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 117 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "GET", path, NULL, &_inner_error_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1144 "feedbinAPI.c"
		} else {
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1152 "feedbinAPI.c"
		}
	}
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1165 "feedbinAPI.c"
}


static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_boxed_free (soup_buffer_get_type (), self);
#line 1174 "feedbinAPI.c"
}


static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1183 "feedbinAPI.c"
}


static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1192 "feedbinAPI.c"
}


static JsonNode*
feedbin_api_parse_json (SoupMessage* response,
                        GError** error)
{
	JsonNode* result = NULL;
	gchar* method = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* uri = NULL;
	SoupURI* _tmp2_;
	SoupURI* _tmp3_;
	gchar* _tmp4_;
	gchar* content = NULL;
	SoupMessageBody* _tmp5_;
	SoupBuffer* _tmp6_;
	SoupBuffer* _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	JsonParser* parser = NULL;
	JsonParser* _tmp20_;
	JsonParser* _tmp37_;
	JsonNode* _tmp38_;
	JsonNode* _tmp39_;
	GError * _inner_error_ = NULL;
#line 122 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (response != NULL, NULL);
#line 124 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (response, "method", &_tmp0_, NULL);
#line 124 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 124 "../plugins/backend/feedbin/feedbinAPI.vala"
	method = _tmp1_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = soup_message_get_uri (response);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = soup_uri_to_string (_tmp3_, FALSE);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	uri = _tmp4_;
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = response->response_body;
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = soup_message_body_flatten (_tmp5_);
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = _tmp6_;
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = _tmp7_->data;
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8__length1 = (gint) _tmp7_->length;
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _tmp9_;
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_SoupBuffer_free0 (_tmp7_);
#line 126 "../plugins/backend/feedbin/feedbinAPI.vala"
	content = _tmp10_;
#line 127 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = content;
#line 127 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp11_ == NULL) {
#line 1261 "feedbinAPI.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		GError* _tmp19_;
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = method;
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = string_to_string (_tmp12_);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = uri;
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = string_to_string (_tmp14_);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = g_strconcat (_tmp13_, " ", _tmp15_, " returned no content but expected JSON", NULL);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp16_;
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp17_);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = _tmp18_;
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp17_);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp19_;
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1302 "feedbinAPI.c"
		} else {
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 129 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1316 "feedbinAPI.c"
		}
	}
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp20_ = json_parser_new ();
#line 132 "../plugins/backend/feedbin/feedbinAPI.vala"
	parser = _tmp20_;
#line 1323 "feedbinAPI.c"
	{
		JsonParser* _tmp21_;
		const gchar* _tmp22_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = parser;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp22_ = content;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		json_parser_load_from_data (_tmp21_, _tmp22_, (gssize) -1, &_inner_error_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1335 "feedbinAPI.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GError* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		GError* _tmp35_;
		GError* _tmp36_;
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp23_ = method;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp24_ = string_to_string (_tmp23_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp25_ = uri;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp26_ = string_to_string (_tmp25_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp27_ = g_strconcat (_tmp24_, " ", _tmp26_, " returned invalid JSON: ", NULL);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp28_ = _tmp27_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp29_ = e;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp30_ = _tmp29_->message;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp31_ = g_strconcat (_tmp28_, _tmp30_, NULL);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp32_ = _tmp31_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp33_ = g_strconcat (_tmp32_, "\nContent is: $content", NULL);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp34_ = _tmp33_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp35_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp34_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp36_ = _tmp35_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp34_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp32_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp28_);
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = _tmp36_;
#line 139 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 1399 "feedbinAPI.c"
		goto __finally0;
	}
	__finally0:
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (parser);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1419 "feedbinAPI.c"
		} else {
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (parser);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1435 "feedbinAPI.c"
		}
	}
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp37_ = parser;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp38_ = json_parser_get_root (_tmp37_);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp39_ = __vala_JsonNode_copy0 (_tmp38_);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp39_;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (parser);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (content);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (uri);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (method);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1456 "feedbinAPI.c"
}


static void
_vala_JsonNode_free (JsonNode* self)
{
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1465 "feedbinAPI.c"
}


static JsonNode*
feedbin_api_get_json (FeedbinAPI* self,
                      const gchar* path,
                      GError** error)
{
	JsonNode* result = NULL;
	SoupMessage* response = NULL;
	SoupMessage* _tmp0_;
	JsonNode* _tmp1_ = NULL;
	SoupMessage* _tmp2_;
	JsonNode* _tmp3_;
	JsonNode* _tmp4_;
	GError * _inner_error_ = NULL;
#line 144 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 144 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_request (self, path, &_inner_error_);
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
	response = _tmp0_;
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1498 "feedbinAPI.c"
		} else {
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 146 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1506 "feedbinAPI.c"
		}
	}
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = response;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = feedbin_api_parse_json (_tmp2_, &_inner_error_);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp3_;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1525 "feedbinAPI.c"
		} else {
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1535 "feedbinAPI.c"
		}
	}
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp1_;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = NULL;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp4_;
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (_tmp1_);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (response);
#line 147 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1550 "feedbinAPI.c"
}


static SoupMessage*
feedbin_api_post_json_object (FeedbinAPI* self,
                              const gchar* path,
                              JsonObject* obj,
                              GError** error)
{
	SoupMessage* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonGenerator* gen = NULL;
	JsonGenerator* _tmp1_;
	gchar* data = NULL;
	gchar* _tmp2_;
	SoupMessage* _tmp3_ = NULL;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError * _inner_error_ = NULL;
#line 150 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 150 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 152 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_node_new (JSON_NODE_OBJECT);
#line 152 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 153 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_node_set_object (root, obj);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = json_generator_new ();
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
	gen = _tmp1_;
#line 156 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_generator_set_root (gen, root);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_generator_to_data (gen, NULL);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	data = _tmp2_;
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_post_request (self, path, data, &_inner_error_);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp4_;
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (data);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (gen);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1611 "feedbinAPI.c"
		} else {
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (data);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (gen);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1625 "feedbinAPI.c"
		}
	}
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp3_;
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = NULL;
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp5_;
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp3_);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (data);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (gen);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 159 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1644 "feedbinAPI.c"
}


gboolean
feedbin_api_login (FeedbinAPI* self,
                   GError** error)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 162 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1656 "feedbinAPI.c"
	{
		SoupMessage* res = NULL;
		SoupMessage* _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = feedbin_api_get_request (self, "authentication.json", &_inner_error_);
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
		res = _tmp0_;
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 166 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED)) {
#line 1670 "feedbinAPI.c"
				goto __catch1_feedbin_error_not_authorized;
			}
			goto __finally1;
		}
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_get (res, "status-code", &_tmp1_, NULL);
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = _tmp1_;
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp2_ == ((guint) SOUP_STATUS_OK);
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (res);
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 1685 "feedbinAPI.c"
	}
	goto __finally1;
	__catch1_feedbin_error_not_authorized:
	{
		GError* e = NULL;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = FALSE;
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 171 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 1701 "feedbinAPI.c"
	}
	__finally1:
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 1706 "feedbinAPI.c"
		gboolean _tmp3_ = FALSE;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error_);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		return _tmp3_;
#line 1712 "feedbinAPI.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error_);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		return _tmp4_;
#line 1721 "feedbinAPI.c"
	}
}


void
feedbin_api_get_subscription (FeedbinAPI* self,
                              gint64 subscription_id,
                              FeedbinAPISubscription* result,
                              GError** error)
{
	JsonNode* root = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	FeedbinAPISubscription _tmp6_ = {0};
	JsonNode* _tmp7_;
	JsonObject* _tmp8_;
	FeedbinAPISubscription _tmp9_;
	GError * _inner_error_ = NULL;
#line 194 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("subscriptions/", _tmp1_, ".json", NULL);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_get_json (self, _tmp3_, &_inner_error_);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp5_;
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1772 "feedbinAPI.c"
		} else {
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1780 "feedbinAPI.c"
		}
	}
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = root;
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = json_node_get_object (_tmp7_);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_init_from_json (&_tmp6_, _tmp8_, &_inner_error_);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1799 "feedbinAPI.c"
		} else {
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1809 "feedbinAPI.c"
		}
	}
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = _tmp6_;
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (&_tmp6_, 0, sizeof (FeedbinAPISubscription));
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	*result = _tmp9_;
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_destroy (&_tmp6_);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	return;
#line 1824 "feedbinAPI.c"
}


static gpointer
_json_array_ref0 (gpointer self)
{
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? json_array_ref (self) : NULL;
#line 1833 "feedbinAPI.c"
}


static gpointer
_json_object_ref0 (gpointer self)
{
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? json_object_ref (self) : NULL;
#line 1842 "feedbinAPI.c"
}


GeeList*
feedbin_api_get_subscriptions (FeedbinAPI* self,
                               GError** error)
{
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* subscriptions = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonNode* _tmp2_;
	JsonArray* _tmp3_;
	JsonArray* _tmp4_;
	GError * _inner_error_ = NULL;
#line 200 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, "subscriptions.json", &_inner_error_);
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1874 "feedbinAPI.c"
		} else {
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1882 "feedbinAPI.c"
		}
	}
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_SUBSCRIPTION, (GBoxedCopyFunc) feedbin_api_subscription_dup, (GDestroyNotify) feedbin_api_subscription_free, NULL, NULL, NULL);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	subscriptions = _tmp1_;
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = root;
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = json_node_get_array (_tmp2_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _json_array_ref0 (_tmp3_);
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp4_;
#line 1897 "feedbinAPI.c"
	{
		gint i = 0;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 1902 "feedbinAPI.c"
		{
			gboolean _tmp5_ = FALSE;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp5_ = TRUE;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 1909 "feedbinAPI.c"
				gint _tmp7_;
				JsonArray* _tmp8_;
				JsonObject* node = NULL;
				JsonArray* _tmp9_;
				gint _tmp10_;
				JsonObject* _tmp11_;
				JsonObject* _tmp12_;
				FeedbinAPISubscription _tmp13_ = {0};
				JsonObject* _tmp14_;
				GeeArrayList* _tmp15_;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp5_) {
#line 1922 "feedbinAPI.c"
					gint _tmp6_;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp6_ = i;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp6_ + 1;
#line 1928 "feedbinAPI.c"
				}
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp5_ = FALSE;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = i;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = array;
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp7_) < json_array_get_length (_tmp8_))) {
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 1940 "feedbinAPI.c"
				}
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = array;
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = i;
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = json_array_get_object_element (_tmp9_, (guint) _tmp10_);
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp12_ = _json_object_ref0 (_tmp11_);
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
				node = _tmp12_;
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp14_ = node;
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_subscription_init_from_json (&_tmp13_, _tmp14_, &_inner_error_);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_propagate_error (error, _inner_error_);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (node);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (subscriptions);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 1972 "feedbinAPI.c"
					} else {
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (node);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (subscriptions);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_clear_error (&_inner_error_);
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 1988 "feedbinAPI.c"
					}
				}
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp15_ = subscriptions;
#line 208 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, &_tmp13_);
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_subscription_destroy (&_tmp13_);
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (node);
#line 1999 "feedbinAPI.c"
			}
		}
	}
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) subscriptions;
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 210 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2011 "feedbinAPI.c"
}


void
feedbin_api_delete_subscription (FeedbinAPI* self,
                                 gint64 subscription_id,
                                 GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError * _inner_error_ = NULL;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("subscriptions/", _tmp1_, ".json", NULL);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_delete_request (self, _tmp3_, NULL, &_inner_error_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp5_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2055 "feedbinAPI.c"
		} else {
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 215 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2063 "feedbinAPI.c"
		}
	}
}


static gpointer
_feedbin_api_subscription_dup0 (gpointer self)
{
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? feedbin_api_subscription_dup (self) : NULL;
#line 2074 "feedbinAPI.c"
}


FeedbinAPISubscription*
feedbin_api_add_subscription (FeedbinAPI* self,
                              const gchar* url,
                              GError** error)
{
	FeedbinAPISubscription* result = NULL;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	GError * _inner_error_ = NULL;
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 221 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = object;
#line 221 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (_tmp1_, "feed_url", url);
#line 2100 "feedbinAPI.c"
	{
		SoupMessage* response = NULL;
		JsonObject* _tmp2_;
		SoupMessage* _tmp3_;
		SoupMessage* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		JsonNode* root = NULL;
		SoupMessage* _tmp8_;
		JsonNode* _tmp9_;
		FeedbinAPISubscription _tmp10_ = {0};
		JsonNode* _tmp11_;
		JsonObject* _tmp12_;
		FeedbinAPISubscription _tmp13_;
		FeedbinAPISubscription _tmp14_;
		FeedbinAPISubscription* _tmp15_;
		FeedbinAPISubscription* _tmp16_;
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = object;
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = feedbin_api_post_json_object (self, "subscriptions.json", _tmp2_, &_inner_error_);
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
		response = _tmp3_;
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2128 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = response;
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_get (_tmp4_, "status-code", &_tmp5_, NULL);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = _tmp5_;
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp6_ == ((guint) 300)) {
#line 2141 "feedbinAPI.c"
			GError* _tmp7_;
#line 227 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp7_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_MULTIPLE_CHOICES, "Site $url has multiple feeds to subscribe to");
#line 227 "../plugins/backend/feedbin/feedbinAPI.vala"
			_inner_error_ = _tmp7_;
#line 227 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 227 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2151 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = response;
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = feedbin_api_parse_json (_tmp8_, &_inner_error_);
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp9_;
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 229 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2168 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = root;
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = json_node_get_object (_tmp11_);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_init_from_json (&_tmp10_, _tmp12_, &_inner_error_);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2187 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = _tmp10_;
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		memset (&_tmp10_, 0, sizeof (FeedbinAPISubscription));
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = _tmp13_;
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = _feedbin_api_subscription_dup0 (&_tmp14_);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = _tmp15_;
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_destroy (&_tmp14_);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp16_;
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_destroy (&_tmp10_);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (response);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 230 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2216 "feedbinAPI.c"
	}
	goto __finally2;
	__catch2_feedbin_error_not_found:
	{
		GError* e = NULL;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = NULL;
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 234 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2234 "feedbinAPI.c"
	}
	__finally2:
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 2245 "feedbinAPI.c"
	} else {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 2255 "feedbinAPI.c"
	}
#line 218 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2259 "feedbinAPI.c"
}


void
feedbin_api_rename_subscription (FeedbinAPI* self,
                                 gint64 subscription_id,
                                 const gchar* title,
                                 GError** error)
{
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GError * _inner_error_ = NULL;
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (title != NULL);
#line 240 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 240 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (object, "title", title);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp1_;
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strconcat ("subscriptions/", _tmp2_, "/update.json", NULL);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp3_;
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = feedbin_api_post_json_object (self, _tmp4_, object, &_inner_error_);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = _tmp5_;
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp6_);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp4_);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp2_);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2316 "feedbinAPI.c"
		} else {
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 242 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2326 "feedbinAPI.c"
		}
	}
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2331 "feedbinAPI.c"
}


void
feedbin_api_add_tagging (FeedbinAPI* self,
                         gint64 feed_id,
                         const gchar* tag_name,
                         GError** error)
{
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError * _inner_error_ = NULL;
#line 259 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 259 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (tag_name != NULL);
#line 261 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 261 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_int_member (object, "feed_id", feed_id);
#line 263 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (object, "name", tag_name);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_post_json_object (self, "taggings.json", object, &_inner_error_);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp1_;
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp2_);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2374 "feedbinAPI.c"
		} else {
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2384 "feedbinAPI.c"
		}
	}
#line 259 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2389 "feedbinAPI.c"
}


void
feedbin_api_delete_tagging (FeedbinAPI* self,
                            gint64 tagging_id,
                            GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError * _inner_error_ = NULL;
#line 269 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, tagging_id);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("taggings/", _tmp1_, ".json", NULL);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_delete_request (self, _tmp3_, NULL, &_inner_error_);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp5_);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2433 "feedbinAPI.c"
		} else {
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2441 "feedbinAPI.c"
		}
	}
}


GeeList*
feedbin_api_get_taggings (FeedbinAPI* self,
                          GError** error)
{
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* taggings = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonArray* _tmp3_;
	GError * _inner_error_ = NULL;
#line 274 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, "taggings.json", &_inner_error_);
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2474 "feedbinAPI.c"
		} else {
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 276 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2482 "feedbinAPI.c"
		}
	}
#line 277 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_TAGGING, (GBoxedCopyFunc) feedbin_api_tagging_dup, (GDestroyNotify) feedbin_api_tagging_free, NULL, NULL, NULL);
#line 277 "../plugins/backend/feedbin/feedbinAPI.vala"
	taggings = _tmp1_;
#line 278 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_node_get_array (root);
#line 278 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _json_array_ref0 (_tmp2_);
#line 278 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp3_;
#line 2495 "feedbinAPI.c"
	{
		gint i = 0;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 2500 "feedbinAPI.c"
		{
			gboolean _tmp4_ = FALSE;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = TRUE;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 2507 "feedbinAPI.c"
				gint _tmp6_;
				JsonArray* _tmp7_;
				JsonObject* object = NULL;
				JsonArray* _tmp8_;
				gint _tmp9_;
				JsonObject* _tmp10_;
				JsonObject* _tmp11_;
				GeeArrayList* _tmp12_;
				JsonObject* _tmp13_;
				FeedbinAPITagging _tmp14_ = {0};
				FeedbinAPITagging _tmp15_;
				FeedbinAPITagging _tmp16_;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp4_) {
#line 2522 "feedbinAPI.c"
					gint _tmp5_;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp5_ = i;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp5_ + 1;
#line 2528 "feedbinAPI.c"
				}
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp4_ = FALSE;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = i;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = array;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp6_) < json_array_get_length (_tmp7_))) {
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 2540 "feedbinAPI.c"
				}
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = array;
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = i;
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = json_array_get_object_element (_tmp8_, (guint) _tmp9_);
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = _json_object_ref0 (_tmp10_);
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
				object = _tmp11_;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp12_ = taggings;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp13_ = object;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_tagging_init_from_json (&_tmp14_, _tmp13_);
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp15_ = _tmp14_;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp16_ = _tmp15_;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, &_tmp16_);
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_tagging_destroy (&_tmp15_);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (object);
#line 2568 "feedbinAPI.c"
			}
		}
	}
#line 284 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) taggings;
#line 284 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 284 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 284 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2580 "feedbinAPI.c"
}


GeeList*
feedbin_api_get_entries (FeedbinAPI* self,
                         gint page,
                         gboolean only_starred,
                         GDateTime* since,
                         gint64* feed_id,
                         GError** error)
{
	GeeList* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* starred = NULL;
	gchar* _tmp1_;
	gchar* path = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	JsonNode* root = NULL;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp26_;
	JsonArray* array = NULL;
	JsonNode* _tmp27_;
	JsonArray* _tmp28_;
	JsonArray* _tmp29_;
	GError * _inner_error_ = NULL;
#line 313 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (only_starred) {
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = "true";
#line 2617 "feedbinAPI.c"
	} else {
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = "false";
#line 2621 "feedbinAPI.c"
	}
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	starred = _tmp1_;
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strdup_printf ("%i", page);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = starred;
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = string_to_string (_tmp4_);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_strconcat ("entries.json?per_page=100&page=", _tmp3_, "&starred=", _tmp5_, "&include_enclosure=true", NULL);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = _tmp6_;
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp7_;
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (since != NULL) {
#line 2645 "feedbinAPI.c"
		GTimeVal t = {0};
		GTimeVal _tmp8_ = {0};
		gboolean _tmp9_;
#line 319 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_get_current_time (&t);
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = g_date_time_to_timeval (since, &_tmp8_);
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
		t = _tmp8_;
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp9_) {
#line 2657 "feedbinAPI.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp10_ = path;
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp11_ = g_time_val_to_iso8601 (&t);
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp12_ = _tmp11_;
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp13_ = g_strconcat ("&since=", _tmp12_, NULL);
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp14_ = _tmp13_;
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp15_ = g_strconcat (_tmp10_, _tmp14_, NULL);
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			path = _tmp15_;
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp14_);
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp12_);
#line 2684 "feedbinAPI.c"
		}
	}
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (feed_id != NULL) {
#line 2689 "feedbinAPI.c"
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, *feed_id);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp16_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = path;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = string_to_string (_tmp18_);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp20_ = g_strconcat ("feeds/", _tmp17_, "/", _tmp19_, NULL);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (path);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		path = _tmp20_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp17_);
#line 2711 "feedbinAPI.c"
	}
	{
		JsonNode* _tmp21_ = NULL;
		const gchar* _tmp22_;
		JsonNode* _tmp23_;
		JsonNode* _tmp24_;
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp22_ = path;
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp23_ = feedbin_api_get_json (self, _tmp22_, &_inner_error_);
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = _tmp23_;
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2728 "feedbinAPI.c"
				goto __catch3_feedbin_error_not_found;
			}
			goto __finally3;
		}
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp24_ = _tmp21_;
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = NULL;
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 332 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp24_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (_tmp21_);
#line 2743 "feedbinAPI.c"
	}
	goto __finally3;
	__catch3_feedbin_error_not_found:
	{
		GError* e = NULL;
		GeeList* _tmp25_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp25_ = gee_list_empty (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free);
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp25_;
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (path);
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (starred);
#line 336 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2768 "feedbinAPI.c"
	}
	__finally3:
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (starred);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2785 "feedbinAPI.c"
		} else {
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (starred);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2799 "feedbinAPI.c"
		}
	}
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp26_ = gee_array_list_new (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free, NULL, NULL, NULL);
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	entries = _tmp26_;
#line 340 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp27_ = root;
#line 340 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp28_ = json_node_get_array (_tmp27_);
#line 340 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp29_ = _json_array_ref0 (_tmp28_);
#line 340 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp29_;
#line 2814 "feedbinAPI.c"
	{
		gint i = 0;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 2819 "feedbinAPI.c"
		{
			gboolean _tmp30_ = FALSE;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp30_ = TRUE;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 2826 "feedbinAPI.c"
				gint _tmp32_;
				JsonArray* _tmp33_;
				JsonObject* object = NULL;
				JsonArray* _tmp34_;
				gint _tmp35_;
				JsonObject* _tmp36_;
				JsonObject* _tmp37_;
				FeedbinAPIEntry _tmp38_ = {0};
				JsonObject* _tmp39_;
				GeeArrayList* _tmp40_;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp30_) {
#line 2839 "feedbinAPI.c"
					gint _tmp31_;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp31_ = i;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp31_ + 1;
#line 2845 "feedbinAPI.c"
				}
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp30_ = FALSE;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp32_ = i;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp33_ = array;
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp32_) < json_array_get_length (_tmp33_))) {
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 2857 "feedbinAPI.c"
				}
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp34_ = array;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp35_ = i;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp36_ = json_array_get_object_element (_tmp34_, (guint) _tmp35_);
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp37_ = _json_object_ref0 (_tmp36_);
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
				object = _tmp37_;
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp39_ = object;
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_entry_init_from_json (&_tmp38_, _tmp39_, &_inner_error_);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_propagate_error (error, _inner_error_);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (object);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (entries);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (path);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (starred);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2893 "feedbinAPI.c"
					} else {
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (object);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (entries);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (path);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (starred);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_clear_error (&_inner_error_);
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2913 "feedbinAPI.c"
					}
				}
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp40_ = entries;
#line 344 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, &_tmp38_);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_entry_destroy (&_tmp38_);
#line 341 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (object);
#line 2924 "feedbinAPI.c"
			}
		}
	}
#line 346 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) entries;
#line 346 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 346 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 346 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 346 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (starred);
#line 346 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2940 "feedbinAPI.c"
}


static guint
__lambda4_ (FeedbinAPI* self,
            gint64* n)
{
	guint result = 0U;
	GHashFunc _tmp0_;
#line 356 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_int64_hash;
#line 356 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_ (n);
#line 356 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2956 "feedbinAPI.c"
}


static guint
___lambda4__gee_hash_data_func (gconstpointer v,
                                gpointer self)
{
	guint result;
	result = __lambda4_ ((FeedbinAPI*) self, (gint64*) v);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2968 "feedbinAPI.c"
}


static gboolean
__lambda5_ (FeedbinAPI* self,
            gint64* a,
            gint64* b)
{
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_int64_equal;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_ (a, b);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2985 "feedbinAPI.c"
}


static gboolean
___lambda5__gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = __lambda5_ ((FeedbinAPI*) self, (gint64*) a, (gint64*) b);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2998 "feedbinAPI.c"
}


static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (gint64, 1);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	memcpy (dup, self, sizeof (gint64));
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 3012 "feedbinAPI.c"
}


static GeeSet*
feedbin_api_get_x_entries (FeedbinAPI* self,
                           const gchar* path,
                           GError** error)
{
	GeeSet* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonArray* array = NULL;
	JsonArray* _tmp1_;
	JsonArray* _tmp2_;
	GeeHashSet* ids = NULL;
	GeeHashSet* _tmp3_;
	GError * _inner_error_ = NULL;
#line 349 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, path, &_inner_error_);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3046 "feedbinAPI.c"
		} else {
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3054 "feedbinAPI.c"
		}
	}
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = json_node_get_array (root);
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _json_array_ref0 (_tmp1_);
#line 352 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp2_;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = gee_hash_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, ___lambda4__gee_hash_data_func, g_object_ref (self), g_object_unref, ___lambda5__gee_equal_data_func, g_object_ref (self), g_object_unref);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	ids = _tmp3_;
#line 3067 "feedbinAPI.c"
	{
		gint i = 0;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 3072 "feedbinAPI.c"
		{
			gboolean _tmp4_ = FALSE;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = TRUE;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 3079 "feedbinAPI.c"
				gint _tmp6_;
				JsonArray* _tmp7_;
				GeeHashSet* _tmp8_;
				JsonArray* _tmp9_;
				gint _tmp10_;
				gint64 _tmp11_;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp4_) {
#line 3088 "feedbinAPI.c"
					gint _tmp5_;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp5_ = i;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = _tmp5_ + 1;
#line 3094 "feedbinAPI.c"
				}
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp4_ = FALSE;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = i;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = array;
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) _tmp6_) < json_array_get_length (_tmp7_))) {
#line 358 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 3106 "feedbinAPI.c"
				}
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = ids;
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = array;
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = i;
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = json_array_get_int_element (_tmp9_, (guint) _tmp10_);
#line 360 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, &_tmp11_);
#line 3118 "feedbinAPI.c"
			}
		}
	}
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeSet*) ids;
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 362 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3130 "feedbinAPI.c"
}


GeeSet*
feedbin_api_get_unread_entries (FeedbinAPI* self,
                                GError** error)
{
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError * _inner_error_ = NULL;
#line 365 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_x_entries (self, "unread_entries.json", &_inner_error_);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3157 "feedbinAPI.c"
		} else {
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3165 "feedbinAPI.c"
		}
	}
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 367 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3178 "feedbinAPI.c"
}


GeeSet*
feedbin_api_get_starred_entries (FeedbinAPI* self,
                                 GError** error)
{
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError * _inner_error_ = NULL;
#line 370 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_x_entries (self, "starred_entries.json", &_inner_error_);
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3205 "feedbinAPI.c"
		} else {
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3213 "feedbinAPI.c"
		}
	}
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 372 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3226 "feedbinAPI.c"
}


static void
feedbin_api_set_entries_status (FeedbinAPI* self,
                                const gchar* type,
                                GeeCollection* entry_ids,
                                gboolean create,
                                GError** error)
{
	JsonArray* array = NULL;
	JsonArray* _tmp0_;
	JsonObject* object = NULL;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	JsonArray* _tmp9_;
	JsonArray* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* path = NULL;
	gchar* _tmp16_;
	JsonObject* _tmp17_;
	SoupMessage* _tmp18_;
	SoupMessage* _tmp19_;
	GError * _inner_error_ = NULL;
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (type != NULL);
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 377 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_array_new ();
#line 377 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp0_;
#line 3261 "feedbinAPI.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) entry_ids);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
		_id_it = _tmp1_;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
		while (TRUE) {
#line 3271 "feedbinAPI.c"
			GeeIterator* _tmp2_;
			gint64* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			JsonArray* _tmp5_;
			gint64* _tmp6_;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp2_ = _id_it;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
				break;
#line 3284 "feedbinAPI.c"
			}
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp3_ = _id_it;
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			id = (gint64*) _tmp4_;
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp5_ = array;
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp6_ = id;
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
			json_array_add_int_element (_tmp5_, *_tmp6_);
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (id);
#line 3300 "feedbinAPI.c"
		}
#line 378 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (_id_it);
#line 3304 "feedbinAPI.c"
	}
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = json_object_new ();
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp7_;
#line 384 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = object;
#line 384 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = array;
#line 384 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _json_array_ref0 (_tmp9_);
#line 384 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_array_member (_tmp8_, type, _tmp10_);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (create) {
#line 3320 "feedbinAPI.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = string_to_string (type);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = g_strconcat (_tmp12_, ".json", NULL);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp11_);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = _tmp13_;
#line 3331 "feedbinAPI.c"
	} else {
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = string_to_string (type);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = g_strconcat (_tmp14_, "/delete.json", NULL);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp11_);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = _tmp15_;
#line 3343 "feedbinAPI.c"
	}
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp16_ = g_strdup (_tmp11_);
#line 386 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp16_;
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp17_ = object;
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp18_ = feedbin_api_post_json_object (self, path, _tmp17_, &_inner_error_);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp19_ = _tmp18_;
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp19_);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp11_);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3373 "feedbinAPI.c"
		} else {
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp11_);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3389 "feedbinAPI.c"
		}
	}
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp11_);
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 375 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 3400 "feedbinAPI.c"
}


void
feedbin_api_set_entries_read (FeedbinAPI* self,
                              GeeCollection* entry_ids,
                              gboolean read,
                              GError** error)
{
	GError * _inner_error_ = NULL;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_entries_status (self, "unread_entries", entry_ids, !read, &_inner_error_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3425 "feedbinAPI.c"
		} else {
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3433 "feedbinAPI.c"
		}
	}
}


void
feedbin_api_set_entries_starred (FeedbinAPI* self,
                                 GeeCollection* entry_ids,
                                 gboolean starred,
                                 GError** error)
{
	GError * _inner_error_ = NULL;
#line 395 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 395 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_entries_status (self, "starred_entries", entry_ids, starred, &_inner_error_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3460 "feedbinAPI.c"
		} else {
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3468 "feedbinAPI.c"
		}
	}
}


GeeMap*
feedbin_api_get_favicons (FeedbinAPI* self,
                          GError** error)
{
	GeeMap* result = NULL;
	GError * _inner_error_ = NULL;
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3482 "feedbinAPI.c"
	{
		JsonNode* root = NULL;
		JsonNode* _tmp0_;
		JsonNode* _tmp1_;
		JsonArray* array = NULL;
		JsonNode* _tmp3_;
		JsonArray* _tmp4_;
		JsonArray* _tmp5_;
		JsonArray* _tmp6_;
		GeeHashMap* favicons = NULL;
		GeeHashMap* _tmp8_;
#line 406 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = feedbin_api_get_json (self, "favicons.json", &_inner_error_);
#line 406 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp0_;
#line 406 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3500 "feedbinAPI.c"
			goto __catch4_g_error;
		}
#line 407 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = root;
#line 407 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp1_ == NULL) {
#line 3507 "feedbinAPI.c"
			GeeMap* _tmp2_;
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp2_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
			result = _tmp2_;
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 408 "../plugins/backend/feedbin/feedbinAPI.vala"
			return result;
#line 3517 "feedbinAPI.c"
		}
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = root;
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = json_node_get_array (_tmp3_);
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp5_ = _json_array_ref0 (_tmp4_);
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
		array = _tmp5_;
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = array;
#line 411 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp6_ == NULL) {
#line 3531 "feedbinAPI.c"
			GeeMap* _tmp7_;
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp7_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
			result = _tmp7_;
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
			return result;
#line 3543 "feedbinAPI.c"
		}
#line 414 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 414 "../plugins/backend/feedbin/feedbinAPI.vala"
		favicons = _tmp8_;
#line 3549 "feedbinAPI.c"
		{
			gint i = 0;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
			i = 0;
#line 3554 "feedbinAPI.c"
			{
				gboolean _tmp9_ = FALSE;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = TRUE;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
				while (TRUE) {
#line 3561 "feedbinAPI.c"
					gint _tmp11_;
					JsonArray* _tmp12_;
					JsonObject* obj = NULL;
					JsonArray* _tmp13_;
					gint _tmp14_;
					JsonObject* _tmp15_;
					JsonObject* _tmp16_;
					gchar* host = NULL;
					JsonObject* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					const gchar* _tmp20_;
					gchar* favicon_encoded = NULL;
					JsonObject* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					GBytes* favicon = NULL;
					const gchar* _tmp25_;
					size_t _tmp26_;
					guchar* _tmp27_;
					GBytes* _tmp28_;
					GeeHashMap* _tmp29_;
					const gchar* _tmp30_;
					GBytes* _tmp31_;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (!_tmp9_) {
#line 3589 "feedbinAPI.c"
						gint _tmp10_;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
						_tmp10_ = i;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
						i = _tmp10_ + 1;
#line 3595 "feedbinAPI.c"
					}
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp9_ = FALSE;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp11_ = i;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp12_ = array;
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (!(((guint) _tmp11_) < json_array_get_length (_tmp12_))) {
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
						break;
#line 3607 "feedbinAPI.c"
					}
#line 417 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp13_ = array;
#line 417 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp14_ = i;
#line 417 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp15_ = json_array_get_object_element (_tmp13_, (guint) _tmp14_);
#line 417 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp16_ = _json_object_ref0 (_tmp15_);
#line 417 "../plugins/backend/feedbin/feedbinAPI.vala"
					obj = _tmp16_;
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp17_ = obj;
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp18_ = json_object_get_string_member (_tmp17_, "host");
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 418 "../plugins/backend/feedbin/feedbinAPI.vala"
					host = _tmp19_;
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp20_ = host;
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_tmp20_ == NULL) {
#line 420 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (host);
#line 420 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (obj);
#line 420 "../plugins/backend/feedbin/feedbinAPI.vala"
						continue;
#line 3637 "feedbinAPI.c"
					}
#line 421 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp21_ = obj;
#line 421 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp22_ = json_object_get_string_member (_tmp21_, "favicon");
#line 421 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 421 "../plugins/backend/feedbin/feedbinAPI.vala"
					favicon_encoded = _tmp23_;
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp24_ = favicon_encoded;
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_tmp24_ == NULL) {
#line 423 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (favicon_encoded);
#line 423 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (host);
#line 423 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (obj);
#line 423 "../plugins/backend/feedbin/feedbinAPI.vala"
						continue;
#line 3659 "feedbinAPI.c"
					}
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp25_ = favicon_encoded;
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp27_ = g_base64_decode (_tmp25_, &_tmp26_);
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp28_ = g_bytes_new_take (_tmp27_, _tmp26_);
#line 424 "../plugins/backend/feedbin/feedbinAPI.vala"
					favicon = _tmp28_;
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp29_ = favicons;
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp30_ = host;
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp31_ = favicon;
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp30_, _tmp31_);
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_bytes_unref0 (favicon);
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (favicon_encoded);
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (host);
#line 415 "../plugins/backend/feedbin/feedbinAPI.vala"
					_json_object_unref0 (obj);
#line 3685 "feedbinAPI.c"
				}
			}
		}
#line 427 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = (GeeMap*) favicons;
#line 427 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_array_unref0 (array);
#line 427 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 427 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 3697 "feedbinAPI.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GeeMap* _tmp32_;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error_;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error_ = NULL;
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp32_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp32_;
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 431 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 3716 "feedbinAPI.c"
	}
	__finally4:
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error_);
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 3725 "feedbinAPI.c"
	} else {
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error_);
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 3733 "feedbinAPI.c"
	}
}


const gchar*
feedbin_api_get_username (FeedbinAPI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->_username;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3751 "feedbinAPI.c"
}


void
feedbin_api_set_username (FeedbinAPI* self,
                          const gchar* value)
{
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (value, feedbin_api_get_username (self)) != 0) {
#line 3763 "feedbinAPI.c"
		gchar* _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (self->priv->_username);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		self->priv->_username = _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY]);
#line 3773 "feedbinAPI.c"
	}
}


const gchar*
feedbin_api_get_password (FeedbinAPI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->_password;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3791 "feedbinAPI.c"
}


void
feedbin_api_set_password (FeedbinAPI* self,
                          const gchar* value)
{
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (value, feedbin_api_get_password (self)) != 0) {
#line 3803 "feedbinAPI.c"
		gchar* _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (self->priv->_password);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		self->priv->_password = _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY]);
#line 3813 "feedbinAPI.c"
	}
}


void
feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self,
                                         JsonObject* object,
                                         GError** error)
{
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GError * _inner_error_ = NULL;
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPISubscription));
#line 185 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_datetime_member (object, "created_at", &_inner_error_);
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3851 "feedbinAPI.c"
		} else {
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3859 "feedbinAPI.c"
		}
	}
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 186 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).created_at = _tmp2_;
#line 187 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = json_object_get_string_member (object, "title");
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).title = _tmp4_;
#line 189 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = json_object_get_string_member (object, "feed_url");
#line 189 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 189 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).feed_url);
#line 189 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_url = _tmp6_;
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = json_object_get_string_member (object, "site_url");
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).site_url);
#line 190 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).site_url = _tmp8_;
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp0_);
#line 3898 "feedbinAPI.c"
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 3907 "feedbinAPI.c"
}


void
feedbin_api_subscription_copy (const FeedbinAPISubscription* self,
                               FeedbinAPISubscription* dest)
{
	gint64 _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gint64 _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).id;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = _tmp0_;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = (*self).created_at;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _g_date_time_ref0 (_tmp1_);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).created_at);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).created_at = _tmp2_;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = (*self).feed_id;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = _tmp3_;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = (*self).title;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).title);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).title = _tmp5_;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = (*self).feed_url;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).feed_url);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_url = _tmp7_;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = (*self).site_url;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).site_url);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).site_url = _tmp9_;
#line 3965 "feedbinAPI.c"
}


void
feedbin_api_subscription_destroy (FeedbinAPISubscription* self)
{
#line 177 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 179 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 180 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).feed_url);
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).site_url);
#line 3980 "feedbinAPI.c"
}


FeedbinAPISubscription*
feedbin_api_subscription_dup (const FeedbinAPISubscription* self)
{
	FeedbinAPISubscription* dup;
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPISubscription, 1);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_copy (self, dup);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 3994 "feedbinAPI.c"
}


void
feedbin_api_subscription_free (FeedbinAPISubscription* self)
{
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_destroy (self);
#line 175 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4005 "feedbinAPI.c"
}


GType
feedbin_api_subscription_get_type (void)
{
	static volatile gsize feedbin_api_subscription_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_subscription_type_id__volatile)) {
		GType feedbin_api_subscription_type_id;
		feedbin_api_subscription_type_id = g_boxed_type_register_static ("FeedbinAPISubscription", (GBoxedCopyFunc) feedbin_api_subscription_dup, (GBoxedFreeFunc) feedbin_api_subscription_free);
		g_once_init_leave (&feedbin_api_subscription_type_id__volatile, feedbin_api_subscription_type_id);
	}
	return feedbin_api_subscription_type_id__volatile;
}


void
feedbin_api_tagging_init_from_json (FeedbinAPITagging *self,
                                    JsonObject* object)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 251 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 251 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPITagging));
#line 253 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 254 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 255 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (object, "name");
#line 255 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 255 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).name);
#line 255 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).name = _tmp1_;
#line 4044 "feedbinAPI.c"
}


void
feedbin_api_tagging_copy (const FeedbinAPITagging* self,
                          FeedbinAPITagging* dest)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).id;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = _tmp0_;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = (*self).feed_id;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = _tmp1_;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = (*self).name;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).name);
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).name = _tmp3_;
#line 4072 "feedbinAPI.c"
}


void
feedbin_api_tagging_destroy (FeedbinAPITagging* self)
{
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).name);
#line 4081 "feedbinAPI.c"
}


FeedbinAPITagging*
feedbin_api_tagging_dup (const FeedbinAPITagging* self)
{
	FeedbinAPITagging* dup;
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPITagging, 1);
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_tagging_copy (self, dup);
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4095 "feedbinAPI.c"
}


void
feedbin_api_tagging_free (FeedbinAPITagging* self)
{
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_tagging_destroy (self);
#line 245 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4106 "feedbinAPI.c"
}


GType
feedbin_api_tagging_get_type (void)
{
	static volatile gsize feedbin_api_tagging_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_tagging_type_id__volatile)) {
		GType feedbin_api_tagging_type_id;
		feedbin_api_tagging_type_id = g_boxed_type_register_static ("FeedbinAPITagging", (GBoxedCopyFunc) feedbin_api_tagging_dup, (GBoxedFreeFunc) feedbin_api_tagging_free);
		g_once_init_leave (&feedbin_api_tagging_type_id__volatile, feedbin_api_tagging_type_id);
	}
	return feedbin_api_tagging_type_id__volatile;
}


void
feedbin_api_entry_init_from_json (FeedbinAPIEntry *self,
                                  JsonObject* object,
                                  GError** error)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* _tmp10_ = NULL;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_ = NULL;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GError * _inner_error_ = NULL;
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPIEntry));
#line 301 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 302 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (object, "title");
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).title = _tmp1_;
#line 304 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_object_get_string_member (object, "url");
#line 304 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 304 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).url);
#line 304 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).url = _tmp3_;
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = json_object_get_string_member (object, "author");
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).author);
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).author = _tmp5_;
#line 306 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = json_object_get_string_member (object, "content");
#line 306 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 306 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).content);
#line 306 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).content = _tmp7_;
#line 307 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = json_object_get_string_member (object, "summary");
#line 307 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 307 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).summary);
#line 307 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).summary = _tmp9_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = feedbin_api_get_datetime_member (object, "published", &_inner_error_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _tmp11_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4205 "feedbinAPI.c"
		} else {
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4213 "feedbinAPI.c"
		}
	}
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = _tmp10_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = NULL;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).published);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).published = _tmp12_;
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp14_ = feedbin_api_get_datetime_member (object, "created_at", &_inner_error_);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = _tmp14_;
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error_->domain == FEEDBIN_ERROR) {
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error_);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_date_time_unref0 (_tmp10_);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4238 "feedbinAPI.c"
		} else {
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_date_time_unref0 (_tmp10_);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error_);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4248 "feedbinAPI.c"
		}
	}
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _tmp13_;
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = NULL;
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 309 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).created_at = _tmp15_;
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp13_);
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp10_);
#line 4263 "feedbinAPI.c"
}


void
feedbin_api_entry_copy (const FeedbinAPIEntry* self,
                        FeedbinAPIEntry* dest)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).id;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = _tmp0_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = (*self).feed_id;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = _tmp1_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = (*self).title;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).title);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).title = _tmp3_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = (*self).url;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).url);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).url = _tmp5_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = (*self).author;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).author);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).author = _tmp7_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = (*self).content;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).content);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).content = _tmp9_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = (*self).summary;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).summary);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).summary = _tmp11_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = (*self).published;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = _g_date_time_ref0 (_tmp12_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).published);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).published = _tmp13_;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp14_ = (*self).created_at;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _g_date_time_ref0 (_tmp14_);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).created_at);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).created_at = _tmp15_;
#line 4351 "feedbinAPI.c"
}


void
feedbin_api_entry_destroy (FeedbinAPIEntry* self)
{
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 292 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).url);
#line 293 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).author);
#line 294 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).content);
#line 295 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).summary);
#line 296 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).published);
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 4372 "feedbinAPI.c"
}


FeedbinAPIEntry*
feedbin_api_entry_dup (const FeedbinAPIEntry* self)
{
	FeedbinAPIEntry* dup;
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPIEntry, 1);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_entry_copy (self, dup);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4386 "feedbinAPI.c"
}


void
feedbin_api_entry_free (FeedbinAPIEntry* self)
{
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_entry_destroy (self);
#line 287 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4397 "feedbinAPI.c"
}


GType
feedbin_api_entry_get_type (void)
{
	static volatile gsize feedbin_api_entry_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_entry_type_id__volatile)) {
		GType feedbin_api_entry_type_id;
		feedbin_api_entry_type_id = g_boxed_type_register_static ("FeedbinAPIEntry", (GBoxedCopyFunc) feedbin_api_entry_dup, (GBoxedFreeFunc) feedbin_api_entry_free);
		g_once_init_leave (&feedbin_api_entry_type_id__volatile, feedbin_api_entry_type_id);
	}
	return feedbin_api_entry_type_id__volatile;
}


static void
feedbin_api_class_init (FeedbinAPIClass * klass)
{
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_parent_class = g_type_class_peek_parent (klass);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_type_class_adjust_private_offset (klass, &FeedbinAPI_private_offset);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_feedbin_api_get_property;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_feedbin_api_set_property;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->finalize = feedbin_api_finalize;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_USERNAME_PROPERTY, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_PASSWORD_PROPERTY, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4431 "feedbinAPI.c"
}


static void
feedbin_api_instance_init (FeedbinAPI * self)
{
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv = feedbin_api_get_instance_private (self);
#line 4440 "feedbinAPI.c"
}


static void
feedbin_api_finalize (GObject * obj)
{
	FeedbinAPI * self;
	SoupSession* _tmp0_;
	guint _tmp1_;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FEEDBIN_API, FeedbinAPI);
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->m_session;
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_parse_name ("authenticate", soup_session_get_type (), &_tmp1_, NULL, FALSE);
#line 49 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self);
#line 29 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (self->priv->m_session);
#line 30 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->m_base_uri);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->_username);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->_password);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (feedbin_api_parent_class)->finalize (obj);
#line 4468 "feedbinAPI.c"
}


GType
feedbin_api_get_type (void)
{
	static volatile gsize feedbin_api_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedbinAPIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feedbin_api_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedbinAPI), 0, (GInstanceInitFunc) feedbin_api_instance_init, NULL };
		GType feedbin_api_type_id;
		feedbin_api_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedbinAPI", &g_define_type_info, 0);
		FeedbinAPI_private_offset = g_type_add_instance_private (feedbin_api_type_id, sizeof (FeedbinAPIPrivate));
		g_once_init_leave (&feedbin_api_type_id__volatile, feedbin_api_type_id);
	}
	return feedbin_api_type_id__volatile;
}


static void
_vala_feedbin_api_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	switch (property_id) {
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_USERNAME_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_value_set_string (value, feedbin_api_get_username (self));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_PASSWORD_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_value_set_string (value, feedbin_api_get_password (self));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4509 "feedbinAPI.c"
		default:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4515 "feedbinAPI.c"
	}
}


static void
_vala_feedbin_api_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	switch (property_id) {
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_USERNAME_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_set_username (self, g_value_get_string (value));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_PASSWORD_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_set_password (self, g_value_get_string (value));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4542 "feedbinAPI.c"
		default:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4548 "feedbinAPI.c"
	}
}



